package com.engine.organization.service;

import com.engine.organization.entity.staff.param.StaffPlanSearchParam;
import com.engine.organization.util.MenuBtn;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @description:
 * @author:dxfeng
 * @createTime: 2022/05/25
 * @version: 1.0
 */
public interface StaffPlanService {
    /**
     * 编制方案列表
     *
     * @param params
     * @return
     */
    Map<String, Object> listPage(StaffPlanSearchParam params);

    /**
     * 新增编制方案
     * @param param
     * @return
     */
    int saveStaffPlan(StaffPlanSearchParam param);

    /**
     * 更新编制方案信息
     *
     * @param param
     * @return
     */
    int updateStaffPlan(StaffPlanSearchParam param);

    /**
     * 更新禁用标记
     *
     * @param params
     */
    int updateForbiddenTagById(StaffPlanSearchParam params);

    /**
     * 根据ID批量删除编制方案
     *
     * @param ids
     */
    int deleteByIds(Collection<Long> ids);

    /**
     * 获取搜索条件
     *
     * @param params
     * @return
     */
    Map<String, Object> getSearchCondition(Map<String, Object> params);


    /**
     * 获取新增、编辑表单
     *
     * @param params
     * @return
     */
    Map<String, Object> getForm(Map<String, Object> params);

    /**
     * 获取列表页面按钮信息
     * @return
     */
    Map<String, List<MenuBtn>> getHasRight();
}
